//Récupération des paramètres GET de l'URL courante
function getParamsQuery() {
    var arrQueries = {};
    $.each(window.location.search.substr(1).split('&'),function(c,q){
        if(q != '') {
            var i = q.split('=');
            if(i.length > 1) {
                arrQueries[i[0].toString()] = i[1].toString();
            }
        }
    });
    return arrQueries;
}


var SaveAsPdf = function( arrTranslations ) {

    this.arrTranslations = arrTranslations;

    var me = this;

    this.onReady = function( ) {
        var $elemPdfDialog = $("#js-pdf-dialog");

        $elemPdfDialog.removeClass('offset');

        $elemPdfDialog.dialog({
            resizable: false,
            dialogClass: 'txtcenter',
            modal: true,
            autoOpen: false,
            closeOnEscape: false,
            draggable: false,
            width: 300
        });

        //On annule le lien href de la balise a
        $('.actipdf').on( 'click', function(e){
            e.preventDefault();

            me.generePDF( $elemPdfDialog, $(this).data('url-generate'), $(this).data('url-download'));
        });

        // Lancement de la popup de print si le paramètre "print=true" est dans l'url
        var arrQueries = getParamsQuery();
        if (arrQueries['pdf']) {
            $('.actipdf').trigger('click');
        }

    };


    // Génère un fichier PDF à partir de la page web actuelle
    this.generePDF = function( $elemPdfDialog, strGeneratePdf, strDownloadPdf ) {

        var srcImg = '';
        if(typeof _baseURL !== 'undefined') {
            srcImg = _baseURL + '/bundles/actimagesaveaspdf/images/load.gif';
        }

        $elemPdfDialog.html('<img src="' + srcImg + '" alt="' + me.arrTranslations['saveaspdf.titleImgLoading'] + '"/><br/><p>' + me.arrTranslations['saveaspdf.labelLoading'] + '</p>');

        //On affiche une boite de dialogue demandant à l'utilisateur de patienter
        $elemPdfDialog.dialog('open');
        $elemPdfDialog.parent().find(".ui-dialog-titlebar-close").hide();

        $.getJSON(
            strGeneratePdf,
            function( data ) {}
        ).success(function(data) {
            $elemPdfDialog.dialog('close');

            //Si il n'y a eu aucune erreur durant la génération du PDF
            if(typeof data.success !== 'undefined' && data.success == true) {

                //Téléchargement du fichier PDF
                window.location.href = strDownloadPdf;
            }

        }).fail(function(jXhr) {
            var data = jXhr.responseJSON;
            //Affiche un message d'erreur
            $elemPdfDialog.html(data.message);
            $elemPdfDialog.parent().find(".ui-dialog-titlebar-close").show();

            if(console) {
                console.log("ActiPDF : " + data.message);
            }

        });
    }
};


